various fixes
[distro-setup] / distro-begin
1 #!/bin/bash -l
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17
18
19 # for bootstrapping a new machine
20
21 # in case we need it,
22 # to make ssh interactive shell run better, we run this first.
23 sudo bash -c 'source /a/c/.bashrc && source /a/exe/ssh-emacs-setup'
24
25
26 # usage: $0 [-r] HOSTNAME
27
28 # tips:
29 # run any sudo command first so your pass is cached
30 # set the scrollback to unlimited in case something goes wrong
31
32 if [[ $EUID == 0 ]]; then
33 if getent passwd ian; then
34 echo "$0: error: running as root. unprivileged user exists. use it."
35 exit 1
36 else
37 echo "$0: warning: running as root. I will setup users then exit"
38 fi
39 fi
40
41 interactive=true # set this to false to force set -x
42 [[ $- == *i* ]] || interactive=false
43
44 if ! $interactive; then
45 set -x
46 set -e -o pipefail
47 fi
48 set -E
49 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
50
51 exec &> >(sudo tee -a /var/log/distro-begin)
52 echo "$0: $(date): starting now)"
53
54 # headless=false # unused atm
55 recompile=false
56 # for copying to a new data fs
57 bootstrapfs=false # old flag, needs new look before using.
58 while [[ $1 == -* ]]; do
59 case $1 in
60 -r) recompile=true; shift ;;
61 esac
62 done
63
64 if [[ $1 ]]; then
65 export HOSTNAME=$1
66 fi
67
68 for f in iank-dev htpc treetowl x2 frodo tp li lj demohost; do
69 eval "$f() { [[ $HOSTNAME == $f ]]; }"
70 done
71 has_p() { treetowl || x2 || frodo || tp || demohost; }
72 has_x() { ! linode; }
73 linode() { lj || li; }
74 has_btrfs() { ! linode; }
75 home_network() { ! linode; }
76 encrypted() { has_p; }
77
78 shopt -s extglob
79 export GLOBIGNORE=*/.:*/..
80 umask 0002
81
82
83 ####### end command line parsing
84
85 PATH="/a/exe:$PATH"
86 sed="sed --follow-symlinks"
87
88 ##### begin setup encryption scripts ######
89 if encrypted; then
90 # I tried making a service which was dependent on reboot.target,
91 # but it happened too late in the shutdown process.
92 sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
93 [Unit]
94 Description=Turn on automatic decryption of drives on boot
95 # tried using graphical.target, but it made my display manager restart before rebooting.
96 # generally, I don't think targets order shutdown like they do startup.
97 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
98 # service that happens late in the game.
99 After=ntp.service
100 DefaultDependencies=no
101 # not sure if needed, makes sure we shut down before reboot.target
102 Conflicts=reboot.target
103
104 [Service]
105 Type=oneshot
106 RemainAfterExit=yes
107 ExecStart=/bin/true
108 ExecStop=/a/exe/keyscript-on
109
110 [Install]
111 WantedBy=keyscriptoff.service
112 EOF
113 sudo systemctl daemon-reload # needed if the file was already there
114 sudo systemctl stop keyscripton.service
115 # sudo systemctl start keyscripton.service
116 sudo systemctl enable keyscripton.service
117
118 sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
119 [Unit]
120 Description=Turn off automatic decryption of drives on boot
121
122 [Service]
123 Type=oneshot
124 ExecStart=/a/exe/keyscript-off
125
126 [Install]
127 WantedBy=multi-user.target
128 EOF
129 sudo systemctl daemon-reload # needed if the file was already there
130 sudo systemctl enable keyscriptoff.service
131 sudo systemctl start keyscriptoff.service
132 fi
133 ##### end setup encryption scripts ######
134
135
136 install-myqueue
137
138 # this script has been designed to be idempotent
139 # todo, it would be nice to cut down on some of the output
140
141
142 for x in /a/bin/errhandle/*-function; do
143 source $x
144 done
145
146
147 set +e
148 $interactive || errcatch
149 set +x
150 source /a/bin/distro-functions/src/identify-distros
151 $interactive || set -x
152
153 if isfedora; then
154 # comment out line disallowing calling sudo in scripts
155 sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
156 # turn on magic sysrq commands for this boot cycle
157 echo 1 > sudo dd of=/proc/sys/kernel/sysrq
158 # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
159 # and you have no idea why.
160 sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
161 selinuxenabled && sudo setenforce 0
162 fi
163
164
165 # already ran for pxe installs, but used for vps & updates
166 distro=$(distro-name)
167 case $distro in
168 ubuntu|debian|trisquel)
169 sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-ian"
170 ;;
171 *)
172 sudo bash -c ". /a/bin/fai/fai-wrapper &&
173 /a/bin/fai/fai/config/distro-install-common/end"
174 ;;
175 esac
176
177 if linode; then
178 sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
179 echo "127.0.1.1 $HOSTNAME.lan $HOSTNAME" | sudo tee -a /etc/hosts
180 fi
181
182
183 if [[ $EUID == 0 ]]; then
184 echo "$0: running as root. exiting now that users are setup"
185 exit 0
186 fi
187
188
189 #### begin link bashrc for root ######
190 for x in /a/c/{.bashrc,brc,.bash_profile,.profile,.inputrc,path_add_function}; do
191 sudo -i <<EOF
192 PATH="/a/exe:$PATH"
193 lnf $x /root
194 EOF
195 done
196 #### end link bashrc repo for root ######
197 # this needs to be before installing pacserve so we have gpg conf.
198 conflink
199
200 set +x
201 errallow
202 source /etc/profile.d/environment.sh
203 source ~/.bashrc
204 $interactive || errcatch
205 $interactive || set -x
206
207
208 # passwordless sudo
209 tu /etc/sudoers <<'EOF'
210 ian ALL=(ALL) NOPASSWD: ALL
211 Defaults env_keep += SUDOD
212 # makes ubuntu be like debian
213 # https://unix.stackexchange.com/a/91572
214 Defaults always_set_home
215 EOF
216
217
218 # enable magic sysrq keys. debian docs say it is already enabled by default
219 isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
220
221
222 if isdeb; then
223 if isdebian-stable && has_x; then
224 codename=$(debian-codename)
225 s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
226 deb http://mozilla.debian.net/ $codename-backports firefox-release
227 deb-src http://mozilla.debian.net/ $codename-backports firefox-release
228 EOF
229 p update
230 # take care of mozilla signing errors in previous command
231 pi pkg-mozilla-archive-keyring
232 p update
233 else
234 :
235 # this would change stable to testing, but I set that up already.
236 # It\'s just a no-op if its already testing.
237 # sudo sed -ri 's!^( *[^ #]+ +[^ ]+ +)[[:alpha:]]+(.*)!\1testing\2!' /etc/apt/sources.list
238 p update
239 fi
240 fi
241
242 if isarch; then
243 #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
244 sudo pacman -S --noconfirm --needed base-devel jq
245 # pacaur seems to be the best, although it + cower has a few minor bugs,
246 # its design goals seem good, so, going for it.
247
248 aurpi() {
249 for p in "$@"; do
250 tempdir=$(mktemp -d)
251 pushd $tempdir
252 aurex "$p"
253 makepkg -sri --skippgpcheck --noconfirm
254 popd
255 rm -rf $tempdir
256 done
257 }
258 aurpi cower pacaur
259
260 pi pacserve
261
262 x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
263 sudo dd of=/etc/pacman.conf if=$x; rm $x
264 sudo systemctl enable pacserve.service
265 sudo systemctl start pacserve.service
266
267 # strange error if just installing trash-cli: "pyalpm requires python",
268 # so I see that it requires python2, and installing that manually fixes it.
269 # I didn't see this on earlier installation, main thing which changed was
270 # pacserve, so not sure if it's related.
271 pi python2
272 fi
273
274 pup
275 pi trash-cli
276
277
278 ###### link files ###########
279 # convenient to just do all file linking in one place
280
281 # if it wasn't set already, we could set hostname here
282 #echo treetowl | s dd of=/etc/hostname
283 #s hostname -F /etc/hostname
284 #HOSTNAME=$(hostname)
285
286
287 s lnf -T /a/bin /b
288 s lnf -T /nocow/t /t
289
290 if has_p; then
291 lnf -T /p/News ~/News
292 fi
293
294 s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
295 /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
296
297 rootsshsync
298
299 s lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
300
301 # machine is going away
302 # if [[ $HOSTNAME == htpc ]]; then
303 # lnf -T /i/Videos ~/Downloads
304 # fi
305
306 if has_p; then
307 # for dovecot
308 lnf -T /i/k/mboxes ~/mail
309 fi
310
311
312 # basic needed packages
313 case $(distro-name) in
314 debian)
315 if has_x; then
316 if isdebian-stable; then
317 pi firefox/$codename-backports
318 else
319 # for a while, firefox/unstable did not have
320 # dependencies satisfied by testing packages, and i hit
321 # a conflict, it wanted a newer libfontconfig1, but
322 # emacs build-deps wanted an older one. In this case,
323 # I switch to using firefox-esr. note: They seem
324 # to release a new esr version every 9 months or so.
325 pi firefox/unstable
326 s dd of=/etc/apt/preferences.d/firefox <<'EOF'
327 Package: firefox
328 Pin: release a=unstable
329 Pin-Priority: 500
330 EOF
331 fi
332 fi
333 # for hosts which require nonfree drivers
334 # i previously had extra packages listed here linux-image-amd64
335 # firmware-linux-free linux-headers-amd64, but I
336 # don\'t see any reason why. seems to work in testing without.
337 # remove this note if it continues to work.
338 p=firmware-linux-nonfree
339 if apt-cache show $p &>/dev/null; then
340 pi $p
341 fi
342 ;;&
343 trisquel|ubuntu|debian)
344 if has_x; then
345 if isdebian-testing; then
346 pi xmacro/unstable # has no unstable deps
347 else
348 pi xmacro
349 fi
350 pi gtk-redshift xinput
351 fi
352 ;;&
353 fedora)
354 p -y groupinstall development-tools c-development books admin-tools
355 pi wget man-pages
356 if has_x; then
357 pi redshift-gtk
358 # debian has this package patched to work, upstream is dead
359 # tried using alien, pi alien, alien -r *.deb, rpm -Uhv *.rpm, got this error, so fuck it
360 # file /usr/bin from install of xmacro-0.3pre_20000911-7.x86_64 conflicts with file from package filesystem-3.2-19.fc20.x86_64
361 # http://packages.debian.org/source/sid/xmacro
362 pi patch libXtst-devel
363 cd $(mktemp -d)
364 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911.orig.tar.gz
365 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911-6.diff.gz
366 ex *.gz
367 patch -p0 < xmacro_0.3pre-20000911-6.diff
368 cd xmacro-0.3pre-20000911.orig
369 make
370 sleep 1 # not sure why the following command couldn\'t find, so trying this
371 # no make install target
372 s cp -f xmacroplay xmacrorec xmacrorec2 /usr/local/bin
373 fi
374 ;;&
375 arch)
376 # like apt-cache
377 pi pkgfile
378 s pkgfile --update
379 if has_x; then
380 # libxtst is missing dep https://aur.archlinux.org/packages/xmacro/#news
381 pi xorg-server redshift xorg-xinput libxtst xmacro
382
383 # background:
384 # https://aur.archlinux.org/packages/xkbset/#comment-545419
385 cert=$(mktemp)
386 cat >$cert <<'EOF'
387 -----BEGIN CERTIFICATE-----
388 MIIJADCCB+igAwIBAgIRAIVAhZ0TMbQ5jTm0koI8X6YwDQYJKoZIhvcNAQELBQAw
389 djELMAkGA1UEBhMCVVMxCzAJBgNVBAgTAk1JMRIwEAYDVQQHEwlBbm4gQXJib3Ix
390 EjAQBgNVBAoTCUludGVybmV0MjERMA8GA1UECxMISW5Db21tb24xHzAdBgNVBAMT
391 FkluQ29tbW9uIFJTQSBTZXJ2ZXIgQ0EwHhcNMTUxMjA4MDAwMDAwWhcNMTgxMjA3
392 MjM1OTU5WjCBsTELMAkGA1UEBhMCVVMxDjAMBgNVBBETBTY1MjExMREwDwYDVQQI
393 EwhNaXNzb3VyaTERMA8GA1UEBxMIQ29sdW1iaWExHzAdBgNVBAkTFjExMDAgQ2Fy
394 cmllIEZyYW5ja2UgRHIxHzAdBgNVBAoTFlVuaXZlcnNpdHkgb2YgTWlzc291cmkx
395 CzAJBgNVBAsTAk1VMR0wGwYDVQQDExRmYWN1bHR5Lm1pc3NvdXJpLmVkdTCCASIw
396 DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN8Kap8hASpxQeqjHibGsCR1PBkh
397 nW9p5FkuhGpMW/3ko8QfxH0W1Hq2y2DTFUmq17kH3GfT3h9a7HcmUrC3q15PciOB
398 WR3j8u0bDfVppyAZXiHJzYGN7xHiPrZtFEGgwZd28+sW80WXTbGl+zKkmeZguGdH
399 AVGeWJEFK44ctLbpjHWCy+xNuhxJuL4olwPoV7WX9IUhceC0rxYQANhLGOJhbchj
400 Z76MA8dc2K3CZI5m7VqQwl09QSnCfz00afUr88ny9vj1S5k2ADS46gaE9O0lM6EY
401 z/uZvMizXN/4ko+hFBjCSt0Vhxjx0kYDSP15btiwh700ywBEubpvLROmd48CAwEA
402 AaOCBUswggVHMB8GA1UdIwQYMBaAFB4Fo3ePbJbiW4dLprSGrHEADOc4MB0GA1Ud
403 DgQWBBTTNWrSb+V/Ayy0i8W2LExMUisQMzAOBgNVHQ8BAf8EBAMCBaAwDAYDVR0T
404 AQH/BAIwADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUHAwIwZwYDVR0gBGAw
405 XjBSBgwrBgEEAa4jAQQDAQEwQjBABggrBgEFBQcCARY0aHR0cHM6Ly93d3cuaW5j
406 b21tb24ub3JnL2NlcnQvcmVwb3NpdG9yeS9jcHNfc3NsLnBkZjAIBgZngQwBAgIw
407 RAYDVR0fBD0wOzA5oDegNYYzaHR0cDovL2NybC5pbmNvbW1vbi1yc2Eub3JnL0lu
408 Q29tbW9uUlNBU2VydmVyQ0EuY3JsMHUGCCsGAQUFBwEBBGkwZzA+BggrBgEFBQcw
409 AoYyaHR0cDovL2NydC51c2VydHJ1c3QuY29tL0luQ29tbW9uUlNBU2VydmVyQ0Ff
410 Mi5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wggOg
411 BgNVHREEggOXMIIDk4IUZmFjdWx0eS5taXNzb3VyaS5lZHWCGmFkdmlzaW5nLmNv
412 YXMubWlzc291cmkuZWR1ghBhaGEubWlzc291cmkuZWR1ghZhbGwtY3JhZnQubWlz
413 c291cmkuZWR1gh1hbWVyaWNhbmJhc2tldHJ5Lm1pc3NvdXJpLmVkdYIXYW5kcmVh
414 cmlldy5taXNzb3VyaS5lZHWCFWFydGdyYWRzLm1pc3NvdXJpLmVkdYIYYmFja3Vw
415 LmNvYXMubWlzc291cmkuZWR1ghBiaWMubWlzc291cmkuZWR1ghZibG9nLmNvYXMu
416 bWlzc291cmkuZWR1ghVjb3dhbmxhYi5taXNzb3VyaS5lZHWCFWRhZS5zdGF0Lm1p
417 c3NvdXJpLmVkdYIRZGljZS5taXNzb3VyaS5lZHWCIGRpZ2l0YWxzdG9yeXRlbGxp
418 bmcubWlzc291cmkuZWR1gg9lYS5taXNzb3VyaS5lZHWCG2Vib29rLWRldi5tYXRo
419 Lm1pc3NvdXJpLmVkdYIXZWJvb2suZWNvbi5taXNzb3VyaS5lZHWCGGVuZ2xpc2g4
420 MDA2Lm1pc3NvdXJpLmVkdYIZZXVnZW5lZml0c2NoLm1pc3NvdXJpLmVkdYIYZXVy
421 b2t1bHR1cmUubWlzc291cmkuZWR1ghNmY2RsYWIubWlzc291cmkuZWR1ghZnZW9t
422 dXNldW0ubWlzc291cmkuZWR1ghRoYXJzdGFkLm1pc3NvdXJpLmVkdYITbHVkd2ln
423 Lm1pc3NvdXJpLmVkdYIYbWFjaGluZXNob3AubWlzc291cmkuZWR1ghNtYWpvcnMu
424 bWlzc291cmkuZWR1ghBtZ2EubWlzc291cmkuZWR1ghdvcmdhbnByaW50Lm1pc3Nv
425 dXJpLmVkdYIUcGh5c2ljcy5taXNzb3VyaS5lZHWCFHBtLmNoZW0ubWlzc291cmku
426 ZWR1ghxyZWNydWl0aW5nLmVjb24ubWlzc291cmkuZWR1ghdyZXBlYy5lY29uLm1p
427 c3NvdXJpLmVkdYIUc2NhbmxhYi5taXNzb3VyaS5lZHWCFnNzc2MuY29hcy5taXNz
428 b3VyaS5lZHWCF3RlYWNoLmNvYXMubWlzc291cmkuZWR1ghd0b3B0ZWFjaGVyLm1p
429 c3NvdXJpLmVkdYIQdnNmLm1pc3NvdXJpLmVkdYIid2hpdGVwYXBlci5ncmFkc2No
430 b29sLm1pc3NvdXJpLmVkdTANBgkqhkiG9w0BAQsFAAOCAQEAQutYVAqG7MpmG2Nu
431 Z/UypjYkN4JvwRbKBpTrce2IT/Sy29x6chBbyD+0WE6QORBtaUHuzE1KoXqpnF4M
432 QrkKw0oBAC6x9dISoomq0DkIndtoBYYLaxSoII6F4OGWgF7pQ/7MiCBYzsKQpn9t
433 aofMcTfvnCjq+MCIaeYnUKBVww0lOJlUxZGKxFJvRpf78HfbBauojjRO2zXLZD/u
434 KMspbTfDaj5etIgWGShY2eml3N/SjAENmZYkcgDBYFyi8CckcEBAVzpH1+D+7Anz
435 txHSYDNHAYLv83MwbegApa1FwPqlG/4SdEU8G6e6Xf5GLC/6GPGVTUpr7o348OOO
436 lzGQzw==
437 -----END CERTIFICATE-----
438 -----BEGIN CERTIFICATE-----
439 MIIF+TCCA+GgAwIBAgIQRyDQ+oVGGn4XoWQCkYRjdDANBgkqhkiG9w0BAQwFADCB
440 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
441 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
442 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTQx
443 MDA2MDAwMDAwWhcNMjQxMDA1MjM1OTU5WjB2MQswCQYDVQQGEwJVUzELMAkGA1UE
444 CBMCTUkxEjAQBgNVBAcTCUFubiBBcmJvcjESMBAGA1UEChMJSW50ZXJuZXQyMREw
445 DwYDVQQLEwhJbkNvbW1vbjEfMB0GA1UEAxMWSW5Db21tb24gUlNBIFNlcnZlciBD
446 QTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJwb8bsvf2MYFVFRVA+e
447 xU5NEFj6MJsXKZDmMwysE1N8VJG06thum4ltuzM+j9INpun5uukNDBqeso7JcC7v
448 HgV9lestjaKpTbOc5/MZNrun8XzmCB5hJ0R6lvSoNNviQsil2zfVtefkQnI/tBPP
449 iwckRR6MkYNGuQmm/BijBgLsNI0yZpUn6uGX6Ns1oytW61fo8BBZ321wDGZq0GTl
450 qKOYMa0dYtX6kuOaQ80tNfvZnjNbRX3EhigsZhLI2w8ZMA0/6fDqSl5AB8f2IHpT
451 eIFken5FahZv9JNYyWL7KSd9oX8hzudPR9aKVuDjZvjs3YncJowZaDuNi+L7RyML
452 fzcCAwEAAaOCAW4wggFqMB8GA1UdIwQYMBaAFFN5v1qqK0rPVIDh2JvAnfKyA2bL
453 MB0GA1UdDgQWBBQeBaN3j2yW4luHS6a0hqxxAAznODAOBgNVHQ8BAf8EBAMCAYYw
454 EgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUH
455 AwIwGwYDVR0gBBQwEjAGBgRVHSAAMAgGBmeBDAECAjBQBgNVHR8ESTBHMEWgQ6BB
456 hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQ2VydGlmaWNh
457 dGlvbkF1dGhvcml0eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNo
458 dHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQWRkVHJ1c3RDQS5j
459 cnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
460 hvcNAQEMBQADggIBAC0RBjjW29dYaK+qOGcXjeIT16MUJNkGE+vrkS/fT2ctyNMU
461 11ZlUp5uH5gIjppIG8GLWZqjV5vbhvhZQPwZsHURKsISNrqOcooGTie3jVgU0W+0
462 +Wj8mN2knCVANt69F2YrA394gbGAdJ5fOrQmL2pIhDY0jqco74fzYefbZ/VS29fR
463 5jBxu4uj1P+5ZImem4Gbj1e4ZEzVBhmO55GFfBjRidj26h1oFBHZ7heDH1Bjzw72
464 hipu47Gkyfr2NEx3KoCGMLCj3Btx7ASn5Ji8FoU+hCazwOU1VX55mKPU1I2250Lo
465 RCASN18JyfsD5PVldJbtyrmz9gn/TKbRXTr80U2q5JhyvjhLf4lOJo/UzL5WCXED
466 Smyj4jWG3R7Z8TED9xNNCxGBMXnMete+3PvzdhssvbORDwBZByogQ9xL2LUZFI/i
467 eoQp0UM/L8zfP527vWjEzuDN5xwxMnhi+vCToh7J159o5ah29mP+aJnvujbXEnGa
468 nrNxHzu+AGOePV8hwrGGG7hOIcPDQwkuYwzN/xT29iLp/cqf9ZhEtkGcQcIImH3b
469 oJ8ifsCnSbu0GB9L06Yqh7lcyvKDTEADslIaeSEINxhO2Y1fmcYFX/Fqrrp1WnhH
470 OjplXuXE0OPa0utaKC25Aplgom88L2Z8mEWcyfoB7zKOfD759AN7JKZWCYwk
471 -----END CERTIFICATE-----
472 -----BEGIN CERTIFICATE-----
473 MIIF3jCCA8agAwIBAgIQAf1tMPyjylGoG7xkDjUDLTANBgkqhkiG9w0BAQwFADCB
474 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
475 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
476 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTAw
477 MjAxMDAwMDAwWhcNMzgwMTE4MjM1OTU5WjCBiDELMAkGA1UEBhMCVVMxEzARBgNV
478 BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBDaXR5MR4wHAYDVQQKExVU
479 aGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2Vy
480 dGlmaWNhdGlvbiBBdXRob3JpdHkwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
481 AoICAQCAEmUXNg7D2wiz0KxXDXbtzSfTTK1Qg2HiqiBNCS1kCdzOiZ/MPans9s/B
482 3PHTsdZ7NygRK0faOca8Ohm0X6a9fZ2jY0K2dvKpOyuR+OJv0OwWIJAJPuLodMkY
483 tJHUYmTbf6MG8YgYapAiPLz+E/CHFHv25B+O1ORRxhFnRghRy4YUVD+8M/5+bJz/
484 Fp0YvVGONaanZshyZ9shZrHUm3gDwFA66Mzw3LyeTP6vBZY1H1dat//O+T23LLb2
485 VN3I5xI6Ta5MirdcmrS3ID3KfyI0rn47aGYBROcBTkZTmzNg95S+UzeQc0PzMsNT
486 79uq/nROacdrjGCT3sTHDN/hMq7MkztReJVni+49Vv4M0GkPGw/zJSZrM233bkf6
487 c0Plfg6lZrEpfDKEY1WJxA3Bk1QwGROs0303p+tdOmw1XNtB1xLaqUkL39iAigmT
488 Yo61Zs8liM2EuLE/pDkP2QKe6xJMlXzzawWpXhaDzLhn4ugTncxbgtNMs+1b/97l
489 c6wjOy0AvzVVdAlJ2ElYGn+SNuZRkg7zJn0cTRe8yexDJtC/QV9AqURE9JnnV4ee
490 UB9XVKg+/XRjL7FQZQnmWEIuQxpMtPAlR1n6BB6T1CZGSlCBst6+eLf8ZxXhyVeE
491 Hg9j1uliutZfVS7qXMYoCAQlObgOK6nyTJccBz8NUvXt7y+CDwIDAQABo0IwQDAd
492 BgNVHQ4EFgQUU3m/WqorSs9UgOHYm8Cd8rIDZsswDgYDVR0PAQH/BAQDAgEGMA8G
493 A1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQEMBQADggIBAFzUfA3P9wF9QZllDHPF
494 Up/L+M+ZBn8b2kMVn54CVVeWFPFSPCeHlCjtHzoBN6J2/FNQwISbxmtOuowhT6KO
495 VWKR82kV2LyI48SqC/3vqOlLVSoGIG1VeCkZ7l8wXEskEVX/JJpuXior7gtNn3/3
496 ATiUFJVDBwn7YKnuHKsSjKCaXqeYalltiz8I+8jRRa8YFWSQEg9zKC7F4iRO/Fjs
497 8PRF/iKz6y+O0tlFYQXBl2+odnKPi4w2r78NBc5xjeambx9spnFixdjQg3IM8WcR
498 iQycE0xyNN+81XHfqnHd4blsjDwSXWXavVcStkNr/+XeTWYRUc+ZruwXtuhxkYze
499 Sf7dNXGiFSeUHM9h4ya7b6NnJSFd5t0dCy5oGzuCr+yDZ4XUmFF0sbmZgIn/f3gZ
500 XHlKYC6SQK5MNyosycdiyA5d9zZbyuAlJQG03RoHnHcAP9Dc1ew91Pq7P8yF1m9/
501 qS3fuQL39ZeatTXaw2ewh0qpKJ4jjv9cJ2vhsE/zB+4ALtRZh8tSQZXq9EfX7mRB
502 VXyNWQKV3WKdwrnuWih0hKWbt5DHDAff9Yk2dDLWKMGwsAvgnEzDHNb842m1R0aB
503 L6KCq9NjRHDEjf8tM7qtj3u1cIiuPhnPQCjY/MiQu12ZIvVS5ljFH4gxQ+6IHdfG
504 jjxDah2nGN59PRbxYvnKkKj9
505 -----END CERTIFICATE-----
506 EOF
507 cat /etc/ssl/certs/ca-certificates.crt >> $cert
508 CURL_CA_BUNDLE=$cert pi xkbset
509 fi
510
511 ;;&
512 ubuntu|trisquel|debian|fedora)
513 if has_x; then
514 if isdebian-testing; then
515 # xkbset was in testing for quite a while, dunno
516 # why it\'s not anymore. Sometime I should check and
517 # see if it\'s back in testing, but the unstable package
518 # doesn\'t upgrade anything form testing, and it\'s tiny
519 # so I\'m not bothering to automate it.
520 pi xkbset/unstable
521 else
522 pi xkbset
523 fi
524 fi
525 ;;&
526 esac
527
528 if has_x; then
529 pi xbindkeys
530 fi
531 pi cryptsetup lvm2
532 # enables trim for volume delete, other rare commands.
533 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
534
535 if encrypted; then
536 if isdeb; then
537 sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
538 fi
539 # does weekly trim
540 sudo systemctl enable fstrim.timer
541 fi
542
543 dirs=(/mnt/{1,2,3,4,5,6,7,8,9})
544 s mkdir -p "${dirs[@]}"
545 s chown ian:ian "${dirs[@]}"
546
547
548 tu /etc/fstab <<'EOF'
549 /i/w /w none bind,noauto 0 0
550 /i/k /k none bind,noauto 0 0
551 EOF
552
553
554 if ! mountpoint /kr; then
555 s mkdir -p /kr
556 s chown ian:traci /kr
557 fi
558
559 if home_network; then
560 if [[ $HOSTNAME == treetowl ]]; then
561 tu /etc/fstab <<'EOF'
562 /k /kr none bind,noauto 0 0
563 EOF
564 else
565 tu /etc/fstab <<'EOF'
566 treetowl:/k /kr nfs noauto 0 0
567 EOF
568 fi
569 fi
570
571 s mkdir -p /q /i/{w,k}
572 for dir in /{i,w,k}; do
573 if mountpoint $dir; then continue; fi # already mounted
574 s mkdir -p $dir
575 s chown ian:ian $dir
576 done
577
578 # not needed for all hosts, but rather just keep it uniform
579 s mkdir -p /mnt/iroot
580
581 # debian auto mounting of multi-disk encrypted btrfs is busted. It is
582 # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
583 # based on 3 of those, it creates .device units for /dev/mapper/dev...
584 # then waits endlessly for them on bootup, after the /dev/mapper disks
585 # have already been created and exist. todo: create a simple repro
586 # for this in a vm and report it upstream.
587 if has_btrfs || home_network; then
588 pi nfs-common
589 s dd of=/root/imount <<'EOF'
590 #!/bin/bash
591 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
592 set -eE -o pipefail
593 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
594 for dir in /i /mnt/iroot /k /kr /w; do
595 if ! mountpoint $dir &>/dev/null && \
596 awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
597 if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
598 mount $dir || echo "warning: failed to mount nfs on $dir"
599 else
600 mount $dir
601 fi
602 fi
603 done
604 EOF
605 s chmod +x /root/imount
606
607 s dd of=/etc/systemd/system/imount.service <<'EOF'
608 [Unit]
609 Description=Mount /i and related mountpoints
610 Before=syncthing@ian.service
611
612 [Service]
613 Type=oneshot
614 ExecStart=/root/imount
615
616 [Install]
617 RequiredBy=syncthing@ian.service
618 # note /kr needs networking, this target is the simplest way to
619 # time it when the network should be up, but not do something
620 # dumb like delay startup until the network is up. It happens
621 # at some time after network.target
622 WantedBy=multi-user.target
623 EOF
624 sudo systemctl daemon-reload # needed if the file was already there
625 sudo systemctl enable imount.service
626 sudo systemctl start imount.service
627 fi
628
629 dir=/nocow
630 if has_btrfs; then
631 if ! mountpoint $dir; then
632 subvol=/mnt/root/nocow
633 if [[ ! -e $subvol ]]; then
634 s btrfs subvolume create $subvol
635 s chown root:1000 $subvol
636 s chattr +C $subvol
637 fi
638
639 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
640 tu /etc/fstab <<EOF
641 $first_root_crypt /nocow btrfs noatime,subvol=nocow 0 0
642 EOF
643 s mkdir -p $dir
644 s chown ian:ian $dir
645 s mount $dir
646 fi
647 else
648 sudo mkdir -p $dir
649 fi
650
651 # ssh and probably some other things care about parent directory
652 # ownership, and ssh doesn\'t allow any group writable parent
653 # directories, so we are forced to use a directory structure similar
654 # to home directories
655 s chown root:ian /q
656 s chmod 755 /q
657
658
659 # it comes with stretch and arch, but not jessie.
660 # propogate /etc/udev/hwdb.d
661 if which systemd-hwdb; then
662 s systemd-hwdb update
663 ser restart systemd-udev-trigger
664 fi
665
666
667 if isdeb; then
668 # I\'ve had problems with postfix on debian:
669 # on stretch, a startup ordering issue caused all mail to fail.
670 # postfix changed defaults to only use ipv6 dns, causing all my mail to fail.
671 # exim4 is default on debian, so I assume it would
672 # be packaged better to avoid these types of things.
673 # I haven\'t gotten around to getting a non-debian exim
674 # setup.
675 mail-setup exim4
676 else
677 mail-setup postfix
678 fi
679
680 if isubuntu; then
681 # disable crash report annoying dialogs.
682 s dd of=/etc/default/apport <<<'enabled=0'
683 fi
684
685 # fai sets this an old way that doesn't work for stretch.
686 # no harm in setting it universally here.
687 # using debconf-set-selection, the area gets reset to ETC
688 # on my linode test machine after doing a dpkg-reconfigure, or a reinstall,
689 # so we are using expect :(
690 # I got a random error when running this, so I added a sleep
691 # rather than trying to write a whole detect and wait loop.
692 # E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
693 # E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
694 sleep 1
695 s apt-get -y install --no-install-recommends expect
696 s expect <<EOF
697 set force_conservative 0
698 spawn dpkg-reconfigure tzdata -freadline
699 expect -nocase timeout {exit 1} "Geographic area:"
700 send "12\r"
701 expect -nocase timeout {exit 1} "Time zone:"
702 send "11\r"
703 expect eof
704 exit
705 EOF
706
707
708 if has_x; then
709 if isarch; then
710 # install so it's build dependencies don't get removed.
711
712 # emacs git build is currently broken
713 if false; then
714 x=$(mktemp -d)
715 pushd $x
716 aurex emacs-git
717 makepkg -si --noconfirm
718 popd
719 rm -rf $x
720 else
721 pi emacs
722 fi
723 pi hunspell hunspell-en
724 else
725 if $recompile; then
726 /a/bin/buildscripts/emacs
727 else
728 /a/bin/buildscripts/emacs --no-r || /a/bin/buildscripts/emacs
729 fi
730 fi
731
732 # todo, figure this out for arch if we ever try out gnome.
733 if ! isarch; then
734 # install for multiple display managers in case we use one
735 if isdeb; then
736 dir=/etc/gdm3
737 elif isfedora; then
738 # fedora didn\'t have the 3.
739 dir=/etc/gdm
740 fi
741 s mkdir -p $dir/PostLogin
742 s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
743 s mkdir /etc/lightdm/lightdm.conf.d
744 s dd of=/etc/lightdm/lightdm.conf.d/12-ian.conf <<'EOF'
745 [SeatDefaults]
746 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
747 EOF
748 fi
749
750
751 pi ghc sakura
752 # todo, also note for work comp, scp opt/org-mode bin/build-scripts
753
754 # use the package manger version to install the cabal version
755 pi cabal-install
756 cabal update
757 PATH="$PATH:$HOME/.cabal/bin"
758
759 # todo, on older ubuntu I used cabal xmonad + xfce,
760 # see /a/bin/old-unused/xmonad-cabal.sh
761
762 # trying out the distros versions newer distros
763 pi xmonad
764 if isarch; then
765 # for displaying error messages.
766 # optional dependency in arch, standard elsewhere.
767 pi xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
768
769 # https://wiki.archlinux.org/index.php/Xinitrc
770 for homedir in /home/*; do
771 cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
772 $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
773 tee -a $homedir/.xinitrc <<'EOF'
774 /a/bin/desktop-20-autostart.sh
775 xsetroot -cursor_name left_ptr
776 exec xmonad
777 EOF
778 done
779 else
780 pi suckless-tools
781 fi
782 pi dmenu
783
784 if tp || x2; then
785 case $distro in
786 debian)
787 pi task-laptop
788 ;;
789 ubuntu|trisquel)
790 # the exact packages that task-laptop would install, since ubuntu
791 # doesn\'t have this virtual in practice package.
792 pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
793 ;;
794 # todo: other distros unknown
795 esac
796 fi
797 fi
798
799 # the first pup command can kill off our /etc/ mod, so rerun this
800 /a/exe/ssh-emacs-setup
801 echo "$0: $(date): ending now"